import {
  select,
  json,
  tsv,
  //data path to svg path
  //geoMercator,
  zoom,
  csv,
  scaleOrdinal,
  schemeYlOrRd
  
} from 'd3';
import {loadAndProcessData} from './loadAndProcessData';

import {colorLegend} from './colorLegend';
import {choroplethMap} from './choroplethMap';


const svg = select('svg');

const choroplethMapG = svg.append('g');

const colorLegendG=svg.append('g')
    .attr('transform', `translate(20,240)`);





const colorScale=scaleOrdinal();

const colorValue=d=>d.properties.prudence;
console.log(colorValue)

let selectedColorValue;
let features;

const onClick=d=>{selectedColorValue=d;
render(); };


loadAndProcessData().then(countries=>{
  features=countries.features;
  render();
//console.log(countries)
 
});




const render=()=>{
  
    colorScale
    .domain(features.map(colorValue))
    .domain(colorScale.domain().sort().reverse())
    .range(schemeYlOrRd[colorScale.domain().length]);
  
  
  colorLegendG
    .call(colorLegend, {
      colorScale,
      circleRadius: 10,
      spacing: 25,
      textOffset: 15,
    backgroundRectWidth:250,
    onClick,
    selectedColorValue
    })
  .append('text')
  .attr('class','legend-title')
  .text('Primary Balance')
  .attr('y',-25)
  .attr('x',-10);
  
  choroplethMapG
    .call(choroplethMap, {
    features, colorScale,colorValue,selectedColorValue
  });

  

  
  
};


